//.............................................................................
//   Program Name: TLP_2622.PRG
//   Copyright: NovaTek Software Inc. 1993-2007
//.............................................................................
#include "DCDIALOG.CH"
#include "Common.ch"
#include "inkey.ch"
#include "set.ch"
#include "setcurs.ch"
#include "std.ch"
#include "get.ch"
#include "getexit.ch"
#include "Appevent.ch"
#include "Xbp.ch"
#include "GRA.ch"
#include "fileio.ch"
#include "dbstruct.ch"
#include "XBtcom.ch"
#define F_BLOCK  512
static process:=.f.
//.............................................................................
/*

StrTran(products->pdescrip,'"','\"')
TLP 2622 Bar Code Label Printer

ASCII TEXT LINE PRINTING
========================
command syntax
A p1,p2,p3,p4,p5,p6,p7,"DATA" //plus cr

Command
A       ASCII data

Parameters
p1      horizontal start position in dots
p2      vertical start position in dots
p3      rotation        0   NONE
                        1   90 degrees
                        2   180 degrees
                        3   290 degrees
p4      font selection  1   20.3 cpi, 6 points (8 x 12 dots)
                        2   16.9 cpi, 7 points (10 x 16 dots)
                        3   14.5 cpi, 10 points (12 x 20 dots)
                        4   12.7 cpi, 12 points, (32 x 48 dots)
                        5   5.6 cpi, 24 points (32 x 48 dots)
                        A-Z reserved for soft fonts
                        Fonts 1-5 are fixed pitch. Appendix B
p5      Horizontal multiplier, expands the text horizontally
        Accessible values 1,2,3,4,6,8
p6      Verticle multiplier, expands the text vertically
        Accessible values 1,2,3,4,5,6,5,8,9
p7      N = normal; R = reverse image

Data
"Data"  Is a fixed data field and can use variables and counters

BAR CODE LINE PRINTING
======================
Command
B       Bar Code

Parameters
p1      horizontal start position in dots
p2      vertical start position in dots
p3      rotation        0   NONE
                        1   90 degrees
                        2   180 degrees
                        3   290 degrees
p4      Bar Code selection          (see options list)
p5      Narrow Bar width in dots    (see options list)
p6      Wide Bar width in dots      (2-30)
p7      Bar Code Height in dots     (limited by size of label)
p8      Print Human readable code   B=yes   N=no

Data
"DATA"  Fixed data field as a barcode
Vnn     V01 = a variable whose context can be 00 to 99
Cn      C1  = a counter with 1 digit number 0 to 9
TT      time printed as barcode (selected printers only)
TD      date printed as barcode (selected printers only)

*/
//.............................................................................
procedure TLP2622(nVar)
    local getlist := {}
    local title, m_view := 'N', m_port := 2, m_source := 0
    local scr := savescreen()
    local mformat := array(6)
    local msource := array(5)
    local mdata   := array(0,30)
    local mNum := y := 0
    local old_color := setcolor()
    local m_print := ''

    private mfile := TRIM(m_usrsyst)+'\Rcvepo.dbf'

    private atlp := array(0,15)
    private mtlp_line := 1
    private mtlp_code := 'A'
    private m26_delay := .01
    private m26_port := 'LPT1'
    private m26_type := '1 '
    private m26_title:= '1 x 1'+space(25)
    private m26_pck1 := space(15)
    private m26_pck2 := space(15)
    private m26_pck3 := space(15)
    private m26_pck4 := space(15)
    private m26_pck5 := space(15)
    private m26_pck6 := space(15)
    private m26_fix1 := space(20)
    private m26_fix2 := space(20)
    private m26_fix3 := space(20)
    private m26_fix4 := space(20)
    private m26_fix5 := space(20)
    private m26_fix6 := space(20)
    private m26_fsz1 := 0
    private m26_fsz2 := 0
    private m26_fsz3 := 0
    private m26_fsz4 := 0
    private m26_fsz5 := 0
    private m26_fsz6 := 0
    private m26_p1   := 0   //height      in mm
    private m26_p2   := 0   //gap         in mm
    private m26_p3   := 0   //bfly offset in mm
    private m26_w1   := 0   //width       in mm
    private m26_dlen := 16
    private m26_wind:=space(40)
    private m26_loc:='P'

    do case
    case nVar = 1
        title := "Barcode Printer Interface"
    case nVar = 2
        m_source := 1
        title := "Barcodes For Inventory by ID Number"
    case nVar = 3
        m_source := 2
        title := "Barcodes For Inventory by Date Received"
    case nVar = 4
        m_source := 3
        title := "Barcodes For Inventory by PO Received"
    case nVar = 5
        title := "Add New Barcode Definition"
    case nVar = 6
        m_source := 4
        title := "Gen X Barcode Printing"
    endcase

    m_bcptr:=get_default()
    if o_tlplbl(.f.,.t.)
        dbsetorder(1)
        if nVar < 5 .or. nVar == 6
          //  if m_bcptr = 0 .or. nVar = 1
          if nVar = 1
               IF pick_2622lbl()
             //     m26_title:=tlplbl->tlp_title
             //     m26_DELAY:=tlplbl->tlp_delay
             //     m26_port :=tlplbl->tlp_port
                  m26_type :=tlplbl->tlp_type
                  m26_wind:=tlplbl->tlp_wind
                  m26_loc:=tlplbl->tlp_loc     //sets port or windows
                //m26_type :=alltrim(tlplbl->tlp_type)
                else
                  dbcloseall()
                  return
                endif
             else
             //  msgbox('not zero')
               if dbseek(str(m_bcptr))
                  m26_type :=tlplbl->tlp_type
                  m26_wind:=tlplbl->tlp_wind
                  m26_loc:=tlplbl->tlp_loc
               else
                  msgbox('Printer Not Found, Please Go to Setup')
                  dbcloseall()
                  return
               endif
             endif
            load_tlplbl(m26_type)  //does the above blocked code???
            tlplbl->(dbclosearea())
            if m26_loc = 'W'
            //do windows stuff here
            else
            //existing port code
               m_print := m_boot[1]+m26_port
               if empty(m_boot[1])
                   m_print := 'C:\'+m26_port
               endif
            endif
    //gui
            if nVar = 1
                E_TLP2622()
                save_tlplbl(m26_type)
                tlplbl->(dbclosearea())
            endif

            set key K_F10 to
            set key K_ALT_F10 to

            if m_source > 0
                load_format(m26_type)
                if m_source==4
                    use (mFile) alias Rcvepo new
                endif
                pick_source(1,@m_source,@msource)
                if m_source > 0
                    mdata := get_mdata(@mdata,@msource,m_source,3)
                    if lastkey() <> K_ESC .and. len(mdata) > 0
                        if m_view = 'Y'
                            cls
                        else
                            m_port:=val(substr(m26_port,4,1))
/*
                            if !empty(m_eltron)
                                set printer to object (m_eltron)
                                set printer on
                            elseif substr(m26_port,1,3) = 'LPT'
                                set printer to (m_print)
                                set printer on
                             endif
*/
                            set console off
                        endif
    /*INITIALIZE BFLY LABELS ONLY*/
                        if m26_type = '2 '
                            init_prtr(2)
                        endif

                        if substr(m26_port,1,3) = 'LPT' .or. m26_loc = 'W'
                            for y := 1 to len(mData)
                                p_tlp2622(mdata,msource,m_view,m26_port,1,y,m_print,m_port)
                                inkey(m26_delay)
                            next y
                        else
                            y:=1
                            p_tlp2622(mdata,msource,m_view,m26_port,1,@y,m_print,m_port)
                        endif
                        if m_view = 'Y'
                            cls
                        else
                      //      if substr(m26_port,1,3) = 'LPT' //.or. !empty(m_eltron)
                      //          set printer to
                      //      endif
                            set console on
                        endif
                    else
                        alertInfo("No Data Found")
                    endif
                endif
                if m_source==4
                    Rcvepo->(dbclosearea())
                endif
            endif
        else
            add_definition(title)
        endif
    end
    dbcloseall()
    release all
    return
//.............................................................................
function add_definition(cVar)
    local getlist:={}
    local mm26_type := space(1)
    local mm26_title:= space(30)
    local mm26_delay := .01
    local mm26_port := 'LPT1'

    @  4,  1 dcsay "Type ID"
    @  4, 16 dcget mm26_type  pict '!!' tabstop
    @  5,  1 dcsay "Description"
    @  5, 16 dcget mm26_title tabstop
    @  6,  1 dcsay "Delay"
    @  6, 16 dcget mm26_delay pict '9.99' tabstop
    @  7,  1 dcsay "Port"
    @  7, 16 dcget mm26_port pict '@!' tabstop

    if EditGui(@GetList,@Process,9,.t.,cVar)
        if !empty(mm26_type) .and. !empty(mm26_title);
            .and. !empty(mm26_delay) .and. !empty(mm26_port)
            tlplbl->(dbappend())
            if !neterr()
//                tlplbl->tlp_type := alltrim(mm26_type)
                tlplbl->tlp_type := mm26_type
                tlplbl->tlp_title:= mm26_title
                tlplbl->tlp_delay:= mm26_delay
                tlplbl->tlp_port := mm26_port
                dbcommit()
                msgbox('Use Barcode Setup to Edit New Label Values')
            endif
        else
            msgbox('Definition not saved')
        endif
    endif
    return''
//.............................................................................
function pick_2622lbl()
    return DNBROWSER('EL','','',0)
//.............................................................................
function p_tlp2622(mdata,msource,m_view,m26_port,nVar,y,m_print,m_port)
    local aLine := array(6), x := 0, t:=0
    local m_swpcall:= m_file := ''
    local ret_val:=.t., oPrinter

//msgbox('top of p_tlp2622')

//format the lines
    for x := 1 to 6 //len(atlp)
        if atlp[x,3] = 'A'
            aLine[x]:=atlp[x,3];
                    +alltrim(atlp[x,4])+',';
                    +alltrim(atlp[x,5])+',';
                    +alltrim(atlp[x,6])+',';
                    +alltrim(atlp[x,7])+',';
                    +alltrim(atlp[x,8])+',';
                    +alltrim(atlp[x,9])+',';
                    +alltrim(atlp[x,10])
        elseif atlp[x,3] = 'B'
            aLine[x]:=atlp[x,3];
                    +alltrim(atlp[x,4])+',';
                    +alltrim(atlp[x,5])+',';
                    +alltrim(atlp[x,6])+',';
                    +alltrim(atlp[x,11])+',';
                    +alltrim(atlp[x,12])+',';
                    +alltrim(atlp[x,13])+',';
                    +alltrim(atlp[x,14])+',';
                    +alltrim(atlp[x,15])
        endif
    next x
//format lines and control upper case for rotation
    fmt_lines('M',@aLine,m_view,mdata,y)  //MULTIPLE ITEMS PER LINE/POSITION
    mData[y,28] := Int(mData[y,28])
    if m_view = 'Y'
        do case
        case m26_type <> '2 '
            ? 'Label Set #     '+str(y,4)
            for x := 1 to 6
                if !empty(aLine[x])
                    ? aLine[x]
                endif
            next x
            ? 'Number to Print '+ltrim(str(mData[y,28]))
            dc_WAIT()
        case m26_type = '2 '
            @ 11,  1 dcsay padc('BUTTERFLY LABEL',78)
            @ 13,  2 dcSAY 'LEFT SIDE'
            @ 13, 42 dcSAY 'RIGHT SIDE'
            @ 15,  2 dcsay TRIM(aLine[1])
            @ 15, 42 dcsay TRIM(aLine[4])
            @ 16,  2 dcsay TRIM(aLine[2])
            @ 16, 42 dcsay TRIM(aLine[5])
            @ 17,  2 dcsay TRIM(aLine[3])
            @ 17, 42 dcsay TRIM(aLine[6])
            @ 20,  2 dcsay 'Number to Print '+ltrim(str(mData[y,28]))
            dc_WAIT()
        endcase
    else
        if substr(m26_port,1,3) = 'LPT' .or. m26_loc = 'W' // BN 11/06 for USB port
           if m26_loc = 'W'
                oPrinter:=XbpPrinter():New()
                oPrinter:Create(trim(m26_wind))
                set printer to OBJECT oPrinter
                set console off
                set print on
            else  //lpt printer
                set printer to (m_print)
                set printer on
                set console off   //BN 9/09 for karen screen problem
            endif
            ? 'N'
            do case
            case m26_type <> '2 '
                for x := 1 to 6
                    if !empty(aLine[x])
                        ? aLine[x]
                    endif
                next x
            case m26_type = '2 '
                ? aLine[1]
                ? aLine[4]
                ? aLine[2]
                ? aLine[5]
                ? aLine[3]
                ? aLine[6]
            endcase
            ? 'P'+LTRIM(str(mData[y,28]))
            ?
           if m26_loc = 'W'
               set printer to
               set device to screen
               oPrinter:destroy()
           else
              set printer to
              set console on   //BN 9/09 for karen screen problem
           endif
        else
// TLP LABELS TO COM PORT PRINT
            m_file := m_usrsyst+'\tlplbl.txt'
            set alternate to (m_file)
            set alternate on
            ? 'N'
            do case
            case m26_type <> '2 '
                ? aLine[1]
                ? aLine[2]
                ? aLine[3]
                ? aLine[4]
                ? aLine[5]
                ? aLine[6]
            case m26_type = '2 '
                ? aLine[1]
                ? aLine[4]
                ? aLine[2]
                ? aLine[5]
                ? aLine[3]
                ? aLine[6]
            endcase
            ? 'P'+LTRIM(str(mData[y,28]))
            ?
            set alternate to
            if com_open(m_port)//,.t.)
                com_init(m_port,9600,'N',8,1)
//added following 01/13/2003
                com_rts(m_port,.t.)
//msgbox('Begin Com Port Run')
                for y:=1 to len(mData)
                    fmt_lines('M',@aLine,m_view,mdata,y)  //MULTIPLE ITEMS PER LINE/POSITION
                    mData[y,28] := Int(mData[y,28])
                    if com_test(m_port)
                        com_send(m_port,'N'+chr(13)+chr(10))
                    else
                        exit
                    endif
                    do case
                    case m26_type <> '2 '
                        if com_test(m_port)
                            for x := 1 to 6
                                if !empty(aLine[x])
                                    com_send(m_port,aLine[x]+chr(13)+chr(10))
                                endif
                            next x
                        else
                            exit
                        endif
                    case m26_type = '2 '
                        if com_test(m_port)
                            com_send(m_port,aLine[1]+chr(13)+chr(10))
                        else
                            exit
                        endif
                        if com_test(m_port)
                            com_send(m_port,aLine[4]+chr(13)+chr(10))
                        else
                            exit
                        endif
                        if com_test(m_port)
                            com_send(m_port,aLine[2]+chr(13)+chr(10))
                        else
                            exit
                        endif
                        if com_test(m_port)
                            com_send(m_port,aLine[5]+chr(13)+chr(10))
                        else
                            exit
                        endif
                        if com_test(m_port)
                            com_send(m_port,aLine[3]+chr(13)+chr(10))
                        else
                            exit
                        endif
                        if com_test(m_port)
                            com_send(m_port,aLine[6]+chr(13)+chr(10))
                        else
                            exit
                        endif
                    endcase
                    if com_test(m_port)
                        com_send(m_port,'P'+LTRIM(str(mData[y,28]))+chr(13)+chr(10))
                    else
                        exit
                    endif
                    if com_test(m_port)
                        com_send(m_port,chr(13)+chr(10))
                    else
                        exit
                    endif
//use delay as needed
                    inkey(m26_delay)
//use this exit to test a single barcode from a batch
                    //exit
                next y
                com_close(m_port)
                if !ret_val
                    msgbox('Check your Com Port Connections')
                endif
            else
                dc_msgbox(,,{'Port Not Initialized'},,,,.f.)
            endif
        endif
    endif
    return''
//.............................................................................
function com_test(m_port)
local t:=.1, ret_val:=.t.
    do while !com_cts(m_port)
        t:=t+.1
        inkey(.1)
        if t >= 30
            msgbox('Com Port Device not Responding')
            ret_val:=.f.
            exit
        endif
        loop
    enddo
    return ret_val
//.............................................................................
function e_tlp2622
    local getlist := {}, old_cursor := setcursor()
    local m_view := 'N'
    local aport:= {'COM1','COM2','COM3','COM4',;
                   'LPT1','LPT2','LPT3','LPT4'}

    local x:=r:=ll := 0, choice := 0
    local acols := array(7)
    local a_wind:={'Windows','Direct to Port'}
    local awind:={'W','P'}
    local a_ptr:=''
    local aptr:={ }

    aptr:=getwprint()  //sucks in windows printer names
    acols[1] := 27
    acols[2] := 33
    acols[3] := 39
    acols[4] := 45
    acols[5] := 51
    acols[6] := 57
    acols[7] := 77
    atlp := array(0,15)
    title:="Print Settings for "+m26_title

    @ 1,  1 dcsay "Windows/Port?"
   @  1, 15 DCget m26_loc  pict '!';
                 TABSTOP GETSIZE 2.5;
                 GETFONT '8.ARIAL';
                 VALID {|o|o:GetData() $ 'WP'};
                 COMBO HEIGHT 2.5 WIDTH 15 DATA a_wind RETURN {|n|awind[n]}

   @ 2,  1 dcsay "Port"   HIDE{||m26_loc = 'W'}
   @ 2, 15 dcget m26_port  pict '!!!9'  ;
                  GETFONT '8.ARIAL';
                  HIDE{||m26_loc = 'W'};
                  GETSIZE 6;
                  COMBO HEIGHT 8 DATA aport RETURN {|n|aport[n]}


    @  2, 1 dcsay "Printer" HIDE{||m26_loc = 'P'}
    @  2, 15 dcget m26_wind;
                  TABSTOP;
                  HIDE{||m26_loc = 'P'};
                  getsize 22;
                  GETFONT '8.ARIAL';
                  COMBO HEIGHT 10 DATA aptr RETURN {|n|aptr[n]}

    @ 3,  1 dcsay "Delay"
    @ 3, 15 dcget m26_delay  pict '99.99' tabstop

    if EditGui(@GetList,@Process,5,.t.,title)
        save_default(m26_type) //saves default to sysusr cmouse
        load_apick()
        load_format(m26_type)
        for x := 1 to len(atlp)
            acols[x]:=21+(x*6)
        next x
        mtlp_line := 1
        do while .t.
            choice := tlpedit_menu()
            do case
            case choice = 1
                edit_lines(@aCols,1)
                if dc_alert("Save Changes",{'Yes','No'}) = 1
                    save_format(m26_type)
                endif
            case choice = 2
                fld_pick()
                if dc_alert("Save Changes",{'Yes','No'}) = 1
                    save_format(m26_type)
                endif
            case choice = 3
                edit_fixtext()
                if dc_alert("Save Changes",{'Yes','No'}) = 1
                    save_format(m26_type)
                endif
            case choice=4
                exit
            endcase
        enddo
    endif
    setcursor(old_cursor)
    set key K_ALT_B to
    clear gets
return''
//.......................................................................
procedure save_default(m26_type)
if o_sysusr(.f.)
   if rec_lock(5)
      sysusr->cmouse:=val(alltrim(m26_type))
      dbcommit()
   endif
   sysusr->(dbclosearea())
endif
return
//..............................................
function get_default()
if o_sysusr(.f.)
 //  if rec_lock(5)
      ret_val:=sysusr->cmouse

 //  endif
   sysusr->(dbclosearea())
endif
return ret_val
//...............................................
function edit_fixtext
    local getlist := {}
    @  4, 1 dcsay "T1 "   get m26_fix1  tabstop
    @  4,31 dcsay "Size " get m26_fsz1 pict '99' tabstop
    @  5, 1 dcsay "T2 "   get m26_fix2 tabstop
    @  5,31 dcsay "Size " get m26_fsz2 pict '99' tabstop
    @  6, 1 dcsay "T3 "   get m26_fix3 tabstop
    @  6,31 dcsay "Size " get m26_fsz3 pict '99' tabstop
    @  7, 1 dcsay "T4 "   get m26_fix4 tabstop
    @  7,31 dcsay "Size " get m26_fsz4 pict '99' tabstop
    @  8, 1 dcsay "T5 "   get m26_fix5 tabstop
    @  8,31 dcsay "Size " get m26_fsz5 pict '99' tabstop
    @  9, 1 dcsay "T6 "   get m26_fix6 tabstop
    @  9,31 dcsay "Size " get m26_fsz6 pict '99' tabstop
    @ 10,31 dcsay "(Leave 0 to auto size)" sayfont '8.arial' saycolor 9

    title:='Edit Fixed Text for '+m26_title

    EditGui(@GetList,@Process,11,.t.,title)

return process
//.......................................................................
function edit_lines(aCols, nvar)
    local get_list := {}
    local ll := 0
    local title:='Line Format for '+m26_title
    local aFont:={}
    local a_BN:={}, aBN:={}
    local a_NR:={}, aNR:={}
    local a_AB:={}, aAB:={}
    local a_rot:={}, aRot:={}
    LOCAL abType:={'0','1','2','3','9','K','2U'}

    a_rot:={'None','90','180','270'}
    aRot:={'0','1','2','3'}

    aadd(a_NR,'Normal')
    aadd(a_NR,'Reversed')
    aadd(aNR,'N')
    aadd(aNR,'R')

    aadd(a_AB,'Alpha')
    aadd(a_AB,'Barcode')
    aadd(aAB,'A')
    aadd(aAB,'B')

    aadd(a_BN,'Yes')
    aadd(a_BN,'No')
    aadd(aBN,'B')
    aadd(aBN,'N')

//edit lines
    @  5,  16 dcsay "LINE 1 "
    @  5,  30 DCSAY "LINE 2 "
    @  5,  44 DCSAY "LINE 3 "
    @  5,  58 DCSAY "LINE 4 "
    @  5,  72 DCSAY "LINE 5 "
    @  5,  86 DCSAY "LINE 6 "
    @  6,  1 dcsay "Type   "saysize 18
    @  7,  1 dcsay "Horz Beg "saysize 18
    @  8,  1 dcsay "Vert Beg "saysize 18
    @  9,  1 dcsay "Rotation "saysize 18
    @ 10,  1 dcsay "Font "saysize 18
    @ 11,  1 dcsay "Horz Multiplier"saysize 18
    @ 12,  1 dcsay "Vert Multiplier"saysize 18
    @ 13,  1 dcsay "Format "saysize 18
    @ 14,  1 dcsay "BarCode Type "saysize 18
    @ 15,  1 dcsay "Nar Bar Width  "saysize 18
    @ 16,  1 dcsay "Wide Bar Width "saysize 18
    @ 17,  1 dcsay "Bar Height     "saysize 18
    @ 18,  1 dcsay "Print Text "saysize 18

    @  6, 16 dcget atlp[1,3] pict '!';
                    TABSTOP;
                    GETSIZE 8;
                    getfont '8.arial';
                    COMBO HEIGHT 2.5 DATA a_AB RETURN {|n|aAB[n]};
                    valid {|o|o:GetData() $ 'AB'}
    @  7, 16 dcget atlp[1,4] pict '999' TABSTOP
    @  8, 16 dcget atlp[1,5] pict '999' TABSTOP
    @  9, 16 dcget atlp[1,6] pict '9';
                    TABSTOP;
                    getsize 6;
                    getfont '8.arial';
                    COMBO HEIGHT 4.5 DATA a_Rot RETURN {|n|aRot[n]};
                    valid {|o|o:GetData() $ '0123'}

    @ 10, 16 dcget atlp[1,7]  pict '!';
                    TABSTOP;
                    popup{||font_sel(atlp[1,7])};
                    when {||atlp[1,3] = 'A'};
                    valid {|o|o:GetData() $ '12345'}
    @ 11, 16 dcget atlp[1,8]  pict '!';
                    TABSTOP;
                    when {||atlp[1,3] = 'A'};
                    valid {|o|o:GetData() $ '123468'}
    @ 12, 16 dcget atlp[1,9]  pict '!';
                    TABSTOP;
                    when {||atlp[1,3] = 'A'};
                    valid {|o|o:GetData() $ '12346789'}
    @ 13, 16 dcget atlp[1,10] pict '!';
                    TABSTOP;
                    when {||atlp[1,3] = 'A'};
                    getsize 8;
                    getfont '8.arial';
                    valid {|o|o:GetData() $ 'NR'};
                    combo Height 2.5 data a_nr RETURN {|n|aNR[n]}
    @ 14, 16 dcget atlp[1,11] pict '!';
                    TABSTOP;
                    popup{||bcode_sel(atlp[1,11])};
                    when {||atlp[1,3] = 'B'};
                    valid {|o|o:GetData() $ '01239KU'}
    @ 15, 16 dcget atlp[1,12] pict '99';
                    TABSTOP;
                    when {||atlp[1,3] = 'B'};
                    valid {||bar_range(atlp[1,12],1,10)}
    @ 16, 16 dcget atlp[1,13] pict '99';
                    TABSTOP;
                    when {||atlp[1,3] = 'B'};
                    valid {||bar_range(atlp[1,13],2,30)}
    @ 17, 16 dcget atlp[1,14] pict '999';
                    TABSTOP;
                    when {||atlp[1,3] = 'B'}
    @ 18, 16 dcget atlp[1,15] pict '!';
                    TABSTOP;
                    when {||atlp[1,3] = 'B'};
                    valid {|o|o:GetData() $ 'BN'};
                    getsize 6;
                    getfont '8.arial';
                    combo Height 2.5 data a_bn RETURN {|n|aBN[n]}

//line 2
    @  6, 30 dcget atlp[2,3] pict '!';
                    TABSTOP;
                    GETSIZE 8;
                    getfont '8.arial';
                    COMBO HEIGHT 2.5 DATA a_AB RETURN {|n|aAB[n]};
                    valid {|o|o:GetData() $ 'AB'}
    @  7, 30 dcget atlp[2,4] pict '999' TABSTOP
    @  8, 30 dcget atlp[2,5] pict '999' TABSTOP
    @  9, 30 dcget atlp[2,6] pict '9';
                    TABSTOP;
                    getsize 6;
                    getfont '8.arial';
                    COMBO HEIGHT 4.5 DATA a_Rot RETURN {|n|aRot[n]};
                    valid {|o|o:GetData() $ '0123'}

    @ 10, 30 dcget atlp[2,7]  pict '!';
                    TABSTOP;
                    popup{||font_sel(atlp[2,7])};
                    when {||atlp[2,3] = 'A'};
                    valid {|o|o:GetData() $ '12345'}
    @ 11, 30 dcget atlp[2,8]  pict '!';
                    TABSTOP;
                    when {||atlp[2,3] = 'A'};
                    valid {|o|o:GetData() $ '123468'}
    @ 12, 30 dcget atlp[2,9]  pict '!';
                    TABSTOP;
                    when {||atlp[2,3] = 'A'};
                    valid {|o|o:GetData() $ '12346789'}
    @ 13, 30 dcget atlp[2,10] pict '!';
                    TABSTOP;
                    when {||atlp[2,3] = 'A'};
                    getsize 8;
                    getfont '8.arial';
                    valid {|o|o:GetData() $ 'NR'};
                    combo Height 2.5 data a_nr RETURN {|n|aNR[n]}
    @ 14, 30 dcget atlp[2,11] pict '!';
                    TABSTOP;
                    popup{||bcode_sel(atlp[2,11])};
                    when {||atlp[2,3] = 'B'};
                    valid {|o|o:GetData() $ '01239KU'}
    @ 15, 30 dcget atlp[2,12] pict '99';
                    TABSTOP;
                    when {||atlp[2,3] = 'B'};
                    valid {||bar_range(atlp[2,12],1,10)}
    @ 16, 30 dcget atlp[2,13] pict '99';
                    TABSTOP;
                    when {||atlp[2,3] = 'B'};
                    valid {||bar_range(atlp[2,13],2,30)}
    @ 17, 30 dcget atlp[2,14] pict '999';
                    TABSTOP;
                    when {||atlp[2,3] = 'B'}
    @ 18, 30 dcget atlp[2,15] pict '!';
                    TABSTOP;
                    when {||atlp[2,3] = 'B'};
                    valid {|o|o:GetData() $ 'BN'};
                    getsize 6;
                    getfont '8.arial';
                    combo Height 2.5 data a_bn RETURN {|n|aBN[n]}

    @  6, 44 dcget atlp[3,3] pict '!';
                    TABSTOP;
                    GETSIZE 8;
                    getfont '8.arial';
                    COMBO HEIGHT 2.5 DATA a_AB RETURN {|n|aAB[n]};
                    valid {|o|o:GetData() $ 'AB'}
    @  7, 44 dcget atlp[3,4] pict '999' TABSTOP
    @  8, 44 dcget atlp[3,5] pict '999' TABSTOP
    @  9, 44 dcget atlp[3,6] pict '9';
                    TABSTOP;
                    getsize 6;
                    getfont '8.arial';
                    COMBO HEIGHT 4.5 DATA a_Rot RETURN {|n|aRot[n]};
                    valid {|o|o:GetData() $ '0123'}

    @ 10, 44 dcget atlp[3,7]  pict '!';
                    TABSTOP;
                    popup{||font_sel(atlp[3,7])};
                    when {||atlp[3,3] = 'A'};
                    valid {|o|o:GetData() $ '12345'}
    @ 11, 44 dcget atlp[3,8]  pict '!';
                    TABSTOP;
                    when {||atlp[3,3] = 'A'};
                    valid {|o|o:GetData() $ '123468'}
    @ 12, 44 dcget atlp[3,9]  pict '!';
                    TABSTOP;
                    when {||atlp[3,3] = 'A'};
                    valid {|o|o:GetData() $ '12346789'}
    @ 13, 44 dcget atlp[3,10] pict '!';
                    TABSTOP;
                    when {||atlp[3,3] = 'A'};
                    getsize 8;
                    getfont '8.arial';
                    valid {|o|o:GetData() $ 'NR'};
                    combo Height 2.5 data a_nr RETURN {|n|aNR[n]}
    @ 14, 44 dcget atlp[3,11] pict '!';
                    TABSTOP;
                    popup{||bcode_sel(atlp[3,11])};
                    when {||atlp[3,3] = 'B'};
                    valid {|o|o:GetData() $ '01239KU'}
    @ 15, 44 dcget atlp[3,12] pict '99';
                    TABSTOP;
                    when {||atlp[3,3] = 'B'};
                    valid {||bar_range(atlp[3,12],1,10)}
    @ 16, 44 dcget atlp[3,13] pict '99';
                    TABSTOP;
                    when {||atlp[3,3] = 'B'};
                    valid {||bar_range(atlp[3,13],2,30)}
    @ 17, 44 dcget atlp[3,14] pict '999';
                    TABSTOP;
                    when {||atlp[3,3] = 'B'}
    @ 18, 44 dcget atlp[3,15] pict '!';
                    TABSTOP;
                    when {||atlp[3,3] = 'B'};
                    valid {|o|o:GetData() $ 'BN'};
                    getsize 6;
                    getfont '8.arial';
                    combo Height 2.5 data a_bn RETURN {|n|aBN[n]}


    @  6, 58 dcget atlp[4,3] pict '!';
                    TABSTOP;
                    GETSIZE 8;
                    getfont '8.arial';
                    COMBO HEIGHT 2.5 DATA a_AB RETURN {|n|aAB[n]};
                    valid {|o|o:GetData() $ 'AB'}

    @  7, 58 dcget atlp[4,4] pict '999' TABSTOP
    @  8, 58 dcget atlp[4,5] pict '999' TABSTOP
    @  9, 58 dcget atlp[4,6] pict '9';
                    TABSTOP;
                    getsize 6;
                    getfont '8.arial';
                    COMBO HEIGHT 4.5 DATA a_Rot RETURN {|n|aRot[n]};
                    valid {|o|o:GetData() $ '0123'}

    @ 10, 58 dcget atlp[4,7]  pict '!';
                    TABSTOP;
                    popup{||font_sel(atlp[4,7])};
                    when {||atlp[4,3] = 'A'};
                    valid {|o|o:GetData() $ '12345'}
    @ 11, 58 dcget atlp[4,8]  pict '!';
                    TABSTOP;
                    when {||atlp[4,3] = 'A'};
                    valid {|o|o:GetData() $ '123468'}
    @ 12, 58 dcget atlp[4,9]  pict '!';
                    TABSTOP;
                    when {||atlp[4,3] = 'A'};
                    valid {|o|o:GetData() $ '12346789'}
    @ 13, 58 dcget atlp[4,10] pict '!';
                    TABSTOP;
                    when {||atlp[4,3] = 'A'};
                    getsize 8;
                    getfont '8.arial';
                    valid {|o|o:GetData() $ 'NR'};
                    combo Height 2.5 data a_nr RETURN {|n|aNR[n]}
    @ 14, 58 dcget atlp[4,11] pict '!';
                    TABSTOP;
                    popup{||bcode_sel(atlp[4,11])};
                    when {||atlp[4,3] = 'B'};
                    valid {|o|o:GetData() $ '01239KU'}
    @ 15, 58 dcget atlp[4,12] pict '99';
                    TABSTOP;
                    when {||atlp[4,3] = 'B'};
                    valid {||bar_range(atlp[4,12],1,10)}
    @ 16, 58 dcget atlp[4,13] pict '99';
                    TABSTOP;
                    when {||atlp[4,3] = 'B'};
                    valid {||bar_range(atlp[4,13],2,30)}
    @ 17, 58 dcget atlp[4,14] pict '999';
                    TABSTOP;
                    when {||atlp[4,3] = 'B'}
    @ 18, 58 dcget atlp[4,15] pict '!';
                    TABSTOP;
                    when {||atlp[4,3] = 'B'};
                    valid {|o|o:GetData() $ 'BN'};
                    getsize 6;
                    getfont '8.arial';
                    combo Height 2.5 data a_bn RETURN {|n|aBN[n]}

    @  6, 72 dcget atlp[5,3] pict '!';
                    TABSTOP;
                    GETSIZE 8;
                    getfont '8.arial';
                    COMBO HEIGHT 2.5 DATA a_AB RETURN {|n|aAB[n]};
                    valid {|o|o:GetData() $ 'AB'}
    @  7, 72 dcget atlp[5,4] pict '999' TABSTOP
    @  8, 72 dcget atlp[5,5] pict '999' TABSTOP
    @  9, 72 dcget atlp[5,6] pict '9';
                    TABSTOP;
                    getsize 6;
                    getfont '8.arial';
                    COMBO HEIGHT 4.5 DATA a_Rot RETURN {|n|aRot[n]};
                    valid {|o|o:GetData() $ '0123'}

    @ 10, 72 dcget atlp[5,7]  pict '!';
                    TABSTOP;
                    popup{||font_sel(atlp[5,7])};
                    when {||atlp[5,3] = 'A'};
                    valid {|o|o:GetData() $ '12345'}
    @ 11, 72 dcget atlp[5,8]  pict '!';
                    TABSTOP;
                    when {||atlp[5,3] = 'A'};
                    valid {|o|o:GetData() $ '123468'}
    @ 12, 72 dcget atlp[5,9]  pict '!';
                    TABSTOP;
                    when {||atlp[5,3] = 'A'};
                    valid {|o|o:GetData() $ '12346789'}
    @ 13, 72 dcget atlp[5,10] pict '!';
                    TABSTOP;
                    when {||atlp[5,3] = 'A'};
                    getsize 8;
                    getfont '8.arial';
                    valid {|o|o:GetData() $ 'NR'};
                    combo Height 2.5 data a_nr RETURN {|n|aNR[n]}
    @ 14, 72 dcget atlp[5,11] pict '!';
                    TABSTOP;
                    popup{||bcode_sel(atlp[5,11])};
                    when {||atlp[5,3] = 'B'};
                    valid {|o|o:GetData() $ '01239KU'}
    @ 15, 72 dcget atlp[5,12] pict '99';
                    TABSTOP;
                    when {||atlp[5,3] = 'B'};
                    valid {||bar_range(atlp[5,12],1,10)}
    @ 16, 72 dcget atlp[5,13] pict '99';
                    TABSTOP;
                    when {||atlp[5,3] = 'B'};
                    valid {||bar_range(atlp[5,13],2,30)}
    @ 17, 72 dcget atlp[5,14] pict '999';
                    TABSTOP;
                    when {||atlp[5,3] = 'B'}
    @ 18, 72 dcget atlp[5,15] pict '!';
                    TABSTOP;
                    when {||atlp[5,3] = 'B'};
                    valid {|o|o:GetData() $ 'BN'};
                    getsize 6;
                    getfont '8.arial';
                    combo Height 2.5 data a_bn RETURN {|n|aBN[n]}

    @  6, 86 dcget atlp[6,3] pict '!';
                    TABSTOP;
                    GETSIZE 8;
                    getfont '8.arial';
                    COMBO HEIGHT 2.5 DATA a_AB RETURN {|n|aAB[n]};
                    valid {|o|o:GetData() $ 'AB'}

    @  7, 86 dcget atlp[6,4] pict '999' TABSTOP
    @  8, 86 dcget atlp[6,5] pict '999' TABSTOP
    @  9, 86 dcget atlp[6,6] pict '9';
                    TABSTOP;
                    getsize 6;
                    getfont '8.arial';
                    COMBO HEIGHT 4.5 DATA a_Rot RETURN {|n|aRot[n]};
                    valid {|o|o:GetData() $ '0123'}

    @ 10, 86 dcget atlp[6,7]  pict '!';
                    TABSTOP;
                    popup{||font_sel(atlp[6,7])};
                    when {||atlp[6,3] = 'A'};
                    valid {|o|o:GetData() $ '12345'}
    @ 11, 86 dcget atlp[6,8]  pict '!';
                    TABSTOP;
                    when {||atlp[6,3] = 'A'};
                    valid {|o|o:GetData() $ '123468'}
    @ 12, 86 dcget atlp[6,9]  pict '!';
                    TABSTOP;
                    when {||atlp[6,3] = 'A'};
                    valid {|o|o:GetData() $ '12346789'}
    @ 13, 86 dcget atlp[6,10] pict '!';
                    TABSTOP;
                    when {||atlp[6,3] = 'A'};
                    getsize 8;
                    getfont '8.arial';
                    valid {|o|o:GetData() $ 'NR'};
                    combo Height 2.5 data a_nr RETURN {|n|aNR[n]}
    @ 14, 86 dcget atlp[6,11] pict '!';
                    TABSTOP;
                    popup{||bcode_sel(atlp[6,11])};
                    when {||atlp[6,3] = 'B'};
                    valid {|o|o:GetData() $ '01239KU'}
    @ 15, 86 dcget atlp[6,12] pict '99';
                    TABSTOP;
                    when {||atlp[6,3] = 'B'};
                    valid {||bar_range(atlp[6,12],1,10)}
    @ 16, 86 dcget atlp[6,13] pict '99';
                    TABSTOP;
                    when {||atlp[6,3] = 'B'};
                    valid {||bar_range(atlp[6,13],2,30)}
    @ 17, 86 dcget atlp[6,14] pict '999';
                    TABSTOP;
                    when {||atlp[6,3] = 'B'}
    @ 18, 86 dcget atlp[6,15] pict '!';
                    TABSTOP;
                    when {||atlp[6,3] = 'B'};
                    valid {|o|o:GetData() $ 'BN'};
                    getsize 6;
                    getfont '8.arial';
                    combo Height 2.5 data a_bn RETURN {|n|aBN[n]}


    EditGui(@GetList,@Process,21,.t.,title)
return''
//.......................................................................
function tlpedit_menu
 //   return dc_alert('Select Edit Option',{'Edit Format','Pick Fields','Fixed Text','Cancel'}, , , , , , ,{'8.Arial','10.Arial'})
return dc_guialert(,'Select Edit Option',{'Edit Format','Pick Fields','Fixed Text','Cancel'}, ,"Bar Code Label Setup")
return choice
//.......................................................................
function e_initprtr
    alertWarn('Initialize Printer Before Program Start')
//    init_prtr(2)
return''
//.......................................................................
function init_prtr(nVar)
    local m_swpcall:=m_file := ''
    do case
    case m26_type = '1 '     //save as 1x1.txt
        m_file := m_usrpath+'\1x1.txt'
    case m26_type = '2 '     //save as bfly.txt
        m_file := m_usrpath+'\bfly.txt'
    endcase
    SET CONSOLE OFF
    if nVar  = 1
        set alternate to (m_file)
        set alternate on
        do case
        case m26_type = '1 '     //save as 1x1.txt
            ? 'Q'+ltrim(str(m26_p1*8))+','+ltrim(str(m26_p2*8))
            ? 'q'+ltrim(str(m26_w1*8))
            ? 'U'
            ?
        case m26_type = '2 '     //save as bfly.txt
            ? 'Q'+ltrim(str(m26_p1*8))+','+ltrim(str(m26_p2*8))+'+'+ltrim(str(m26_p3*8))
            ? 'q'+ltrim(str(m26_w1*8))
            ? 'U'
            ?
        endcase
        CLOSE ALTERNATE
    endif
    if nVar = 2
        if file(m_File) .and. dc_alert("Initialize Printer Now?",{'No','Yes'}) = 2
            m_swpcall := 'TYPE '+;
                        (m_file)+;
                        ' > '+;
                        m26_port
            RunShell( m_swapcall,,.T.)
            if substr(m26_port,1,3) = 'COM'
                m_swpcall := 'MODE '+m26_port+': 96,N,8,1'
                RunShell( m_swapcall,,.T.)
            endif
        endif
    endif
    SET CONSOLE ON
    return''
//.......................................................................
function test_fmt
    do case
    case m26_type = '1 '     //save as 1x1.txt
        if m26_p1 = 0
            m26_p1 := 25
        endif
        if m26_p2 = 0
            m26_p2 := 3
        endif
        if m26_w1 = 0
            m26_w1 := 30
        endif
    case m26_type = '2 '     //save as bfly.txt
        if m26_p1 = 0
            m26_p1 := 15
        endif
        if m26_p2 = 0
            m26_p2 := 4
        endif
        if m26_p3 = 0
            m26_p3 := 5
        endif
        if m26_w1 = 0
            m26_w1 := 50
        endif
    endcase
    return''
//.......................................................................
function lbl_size
    local getlist := {}
    local scr := savescreen(18,1,23,40)
    local old_color := setcolor()
    @ 18, 1 clear to 22,40
    @ 18, 1 to 23,40
    setcolor(ccolor[2])
    @ 19, 2 say "LABEL SIZING in mm:"
    @ 20,  2 say "Width :"
    @ 20, 22 say "Height:"
    @ 21,  2 say "Gap Between Labels:"
    if m26_type = '2 '
        @ 22,  2 say "Butterfly Offset  :"
    end
    do while .t.
        setcolor(ccolor[2])
        @ 20, 10 get m26_w1 pict '999.9'
        @ 20, 30 get m26_p1 pict '999.9'
        @ 21, 22 get m26_p2 pict '999.9'
        if m26_type = '2 '
            @ 22, 22 get m26_p3 pict '999.9'
        endif
        setcursor(1)
        read
        setcursor(0)
        if lastkey() = K_PGDN
            exit
        endif
    enddo
    restscreen(18,1,23,40,scr)
    setcolor(old_color)
return''
//.......................................................................
function fld_pick()
    local getlist := {}
    m26_pck1 := substr(m26_pck1+space(15),1,15)
    m26_pck2 := substr(m26_pck2+space(15),1,15)
    m26_pck3 := substr(m26_pck3+space(15),1,15)
    m26_pck4 := substr(m26_pck4+space(15),1,15)
    m26_pck5 := substr(m26_pck5+space(15),1,15)
    m26_pck6 := substr(m26_pck6+space(15),1,15)
    @  2, 30 dcsay "1  UPC Code"
    @  3, 30 dcsay "2  Prod ID "
    @  4, 30 dcsay "3  Description"
    @  5, 30 dcsay "4  Department"
    @  6, 30 dcsay "5  Class   "
    @  7, 30 dcsay "6  List    "
    @  8, 30 dcsay "7  Price A "
    @  9, 30 dcsay "8  Price B "
    @ 10, 30 dcsay "9  Price C "
    @ 11, 30 dcsay "10 Price D "
    @  2, 50 dcsay "11 Price E "
    @  3, 50 dcsay "12 "+substr(m_u1scr,1,8)  saysize 15 //" POUNDS
    @  4, 50 dcsay "13 "+substr(m_u2scr,1,8) saysize 15   //" POUNCES
    @  5, 50 dcsay "14 "+substr(m_u3scr,1,8)  saysize 15  //" PYEAR
    @  6, 50 dcsay "15 "+substr(m_u4scr,1,8)  saysize 15  //" PBRAND
    @  7, 50 dcsay "16 "+substr(m_u5scr,1,8)  saysize 15  //" PMODEL
    @  8, 50 dcsay "17 "+substr(m_u6scr,1,8)  saysize 15  //" PSTYLE
    @  9, 50 dcsay "18 "+substr(m_u7scr,1,8)  saysize 15  //" PMANUFAC
    @ 10, 50 dcsay "19 "+substr(m_u8scr,1,8)  saysize 15  //" PSIZE
    @ 11, 50 dcsay "20 "+substr(m_u9scr,1,8)  saysize 15  //" PMAKE
    @  2, 70 dcsay "21 Commission"
    @  3, 70 dcsay "22 Fix1 "+m26_fix1
    @  4, 70 dcsay "23 Fix2 "+m26_fix2
    @  5, 70 dcsay "24 Fix3 "+m26_fix3
    @  6, 70 dcsay "25 Fix4 "+m26_fix4
    @  7, 70 dcsay "26 Fix5 "+m26_fix5
    @  8, 70 dcsay "27 Fix6 "+m26_fix6
//    @  9, 70 dcsay "28 Reserved "
    @ 10, 70 dcsay "29 Primary Vendor "
    @ 11, 70 dcsay "30 Vendor Part "

    do case
    case m26_type <> '2 '
        @  2, 1 dcsay 'Ln 1'get m26_pck1 tabstop
        @  3, 1 dcsay 'Ln 2'get m26_pck2 tabstop
        @  4, 1 dcsay 'Ln 3'get m26_pck3 tabstop
        @  5, 1 dcsay 'Ln 4'get m26_pck4 tabstop
        @  6, 1 dcsay 'Ln 5'get m26_pck5 tabstop
        @  7, 1 dcsay 'Ln 6'get m26_pck6 tabstop
        @  9, 1 dcSAY "Desc Length "get m26_dlen pict '99'  tabstop
    case m26_type = '2 '
        @  2, 1 dcsay 'Ln 1'get m26_pck1 tabstop
        @  3, 1 dcsay 'Ln 2'get m26_pck2 tabstop
        @  4, 1 dcsay 'Ln 3'get m26_pck3 tabstop
        @  5, 1 dcsay 'Ln 4'get m26_pck4 tabstop
        @  6, 1 dcsay 'Ln 5'get m26_pck5 tabstop
        @  7, 1 dcsay 'Ln 6'get m26_pck6 tabstop
        @  9, 1 dcSAY "Desc Length "get m26_dlen pict '99'  tabstop
    endcase

    title:='Pick Fields for Lines for '+m26_title

    EditGui(@GetList,@Process,11,.t.,title)

//    show_fields()

return process
//.......................................................................
function load_apick()
//initialize user defined fields
    if empty(m_u1scr)
        m_u1scr := 'Weight  '
    endif
    if empty(m_u2scr)
        m_u2scr := 'Ounces  '
    endif
    if empty(m_u3scr)
        m_u3scr := 'Year    '
    endif
    if empty(m_u4scr)
        m_u4scr := 'Brand   '
    endif
    if empty(m_u5scr)
        m_u5scr := 'Model   '
    endif
    if empty(m_u6scr)
        m_u6scr := 'Style   '
    endif
    if empty(m_u7scr)
        m_u7scr := 'Manufac.'
    endif
    if empty(m_u8scr)
        m_u8scr := 'Size    '
    endif
    if empty(m_u9scr)
        m_u9scr := 'Make    '
    endif
//user defined field names
    return''
//.......................................................................
static function save_format(m26_type)
    local x := 0
    if o_tlp2622(.f.,.t.)
        for x := 1 to 6//len(atlp)
            atlp[x,1]:=m26_type//alltrim(m26_type)
            atlp[x,2]:=ltrim(str(x))
            if !dbseek(atlp[x,1]+atlp[x,2])
                dbappend()
            endif
            sav_tlp2622(x)
        next x
        tlp2622->(dbclosearea())
    endif
    return''
//.............................................................................
function load_tlplbl(cVar)
    if tlplbl->(dbseek(cVar))
//        m26_type:=trim(TLPLBL->tlp_type)
        m26_type:=TLPLBL->tlp_type
        m26_title:=TLPLBL->tlp_title
        m26_port:=TLPLBL->tlp_port
        m26_delay:=TLPLBL->tlp_delay
        m26_wind:=tlplbl->tlp_wind
        m26_loc:=tlplbl->tlp_loc
    endif
return''
//.............................................................................
function save_tlplbl(cVar)
    if o_tlplbl(.f.,.t.)
        if dbseek(cVar)
            rlock()
            TLPLBL->tlp_type :=m26_type
            TLPLBL->tlp_title:=m26_title
            TLPLBL->tlp_port :=m26_port
            TLPLBL->tlp_delay:=m26_delay
            TLPLBL->tlp_loc:=m26_loc
            TLPLBL->tlp_wind:=m26_wind
            dbcommit()
            dbrunlock()
        endif
    endif
return''
//.............................................................................
function bld_tlplbl()
    local ret_val := .f., aStructure
    @ 14, 0 say padc("Rebuilding TlpLbl.dbf File",80)
    inkey(1)
    del_index('tlplbl.cdx')
    aStructure:={{"tlp_type  ","C", 2,0},;
                {"tlp_title ","C",25,0},;
                {"tlp_port  ","C", 4,0},;
                {"tlp_delay ","N", 4,2} }
    db_create("templbl",aStructure)
    if file('tlplbl.dbf')
        if net_use("templbl","templbl",.t.,5)// exclusive new
            append from tlplbl
            templbl->(dbclosearea())
        endif
    endif
    copy file ('templbl.dbf') to ('tlplbl.dbf')
    if file('tlplbl.dbf')
        if o_tlplbl(.f.,.t.)
            tlplbl->(dbclosearea())
        endif
    endif
    @ 14, 0 say padc("Rebuilding Complete",80)
    inkey(1)
    @ 14, 0 clear to 14, 78
    return .T.
//.............................................................................
function bld_tlp2622()
    local ret_val := .f., aStructure
    @ 14, 0 say padc("Rebuilding File",80)
    inkey(1)
    del_index('tlp2622.cdx')
    aStructure:={{"tlp_type  ","C", 2,0},;
                {"tlp_line  ","C", 1,0},;
                {"tlp_code  ","C", 1,0},;
                {"tlp_hor   ","C", 3,0},;
                {"tlp_ver   ","C", 3,0},;
                {"tlp_rot   ","C", 1,0},;
                {"tlp_font  ","C", 1,0},;
                {"tlp_hmult ","C", 1,0},;
                {"tlp_vmult ","C", 1,0},;
                {"tlp_image ","C", 1,0},;
                {"tlp_bcode ","C", 3,0},;
                {"tlp_nbw   ","C", 2,0},;
                {"tlp_wbw   ","C", 2,0},;
                {"tlp_bhght ","C", 3,0},;
                {"tlp_phrc  ","C", 1,0},;
                {"tlp_title ","C",25,0},;
                {"tlp_pck1  ","C",15,0},;
                {"tlp_pck2  ","C",15,0},;
                {"tlp_pck3  ","C",15,0},;
                {"tlp_pck4  ","C",15,0},;
                {"tlp_pck5  ","C",15,0},;
                {"tlp_pck6  ","C",15,0},;
                {"tlp_fix1  ","C",20,0},;
                {"tlp_fix2  ","C",20,0},;
                {"tlp_fix3  ","C",20,0},;
                {"tlp_fix4  ","C",20,0},;
                {"tlp_fix5  ","C",20,0},;
                {"tlp_fix6  ","C",20,0},;
                {"tlp_fsz1  ","N", 2,0},;
                {"tlp_fsz2  ","N", 2,0},;
                {"tlp_fsz3  ","N", 2,0},;
                {"tlp_fsz4  ","N", 2,0},;
                {"tlp_fsz5  ","N", 2,0},;
                {"tlp_fsz6  ","N", 2,0},;
                {"tlp_p1    ","N", 6,2},;
                {"tlp_p2    ","N", 6,2},;
                {"tlp_p3    ","N", 6,2},;
                {"tlp_w1    ","N", 6,2},;
                {"tlp_dlen  ","N", 2,0} ;
                }
    db_create("templbl",aStructure)
    if file('tlp2622.dbf')
        if net_use("templbl","templbl",.t.,5)// exclusive new
            append from tlp2622
            templbl->(dbclosearea())
        endif
    endif
    copy file ('templbl.dbf') to ('tlp2622.dbf')
    if file('tlp2622.dbf')
        if o_tlplbl(.f.,.t.)
            tlplbl->(dbclosearea())
        endif
    endif
    @ 14, 0 say padc("Rebuilding Complete",80)
    inkey(1)
    @ 14, 0 clear to 14, 78
    return .T.
//.............................................................................
function sav_tlp2622(x)
    dbrlock()
    tlp2622->tlp_type  := atlp[X,1]
    tlp2622->tlp_line  := atlp[X,2]
    tlp2622->tlp_code  := atlp[X,3]
    tlp2622->tlp_hor   := atlp[X,4]
    tlp2622->tlp_ver   := atlp[X,5]
    tlp2622->tlp_rot   := atlp[X,6]
    if atlp[x,3] = 'A'
        tlp2622->tlp_font  := atlp[X,7]
        tlp2622->tlp_hmult := atlp[X,8]
        tlp2622->tlp_vmult := atlp[X,9]
        tlp2622->tlp_image := atlp[X,10]

        tlp2622->tlp_bcode := '  '
        tlp2622->tlp_nbw   := ''
        tlp2622->tlp_wbw   := ''
        tlp2622->tlp_bhght := ''
        tlp2622->tlp_phrc  := ''
    elseif atlp[x,3] = 'B'
        tlp2622->tlp_bcode := atlp[X,11]
        tlp2622->tlp_nbw   := atlp[X,12]
        tlp2622->tlp_wbw   := atlp[X,13]
        tlp2622->tlp_bhght := atlp[X,14]
        tlp2622->tlp_phrc  := atlp[X,15]

        tlp2622->tlp_font  := ''
        tlp2622->tlp_hmult := ''
        tlp2622->tlp_vmult := ''
        tlp2622->tlp_image := ''
    endif
    if x = 1
        tlp2622->tlp_title := m26_title
        tlp2622->tlp_pck1  := m26_pck1
        tlp2622->tlp_pck2  := m26_pck2
        tlp2622->tlp_pck3  := m26_pck3
        tlp2622->tlp_pck4  := m26_pck4
        tlp2622->tlp_pck5  := m26_pck5
        tlp2622->tlp_pck6  := m26_pck6
        tlp2622->tlp_fix1  := m26_fix1
        tlp2622->tlp_fix2  := m26_fix2
        tlp2622->tlp_fix3  := m26_fix3
        tlp2622->tlp_fix4  := m26_fix4
        tlp2622->tlp_fix5  := m26_fix5
        tlp2622->tlp_fix6  := m26_fix6
        tlp2622->tlp_fsz1  := m26_fsz1
        tlp2622->tlp_fsz2  := m26_fsz2
        tlp2622->tlp_fsz3  := m26_fsz3
        tlp2622->tlp_fsz4  := m26_fsz4
        tlp2622->tlp_fsz5  := m26_fsz5
        tlp2622->tlp_fsz6  := m26_fsz6
        tlp2622->tlp_p1    := m26_p1 * 8
        tlp2622->tlp_p2    := m26_p2 * 8
        tlp2622->tlp_p3    := m26_p3 * 8
        tlp2622->tlp_w1    := m26_w1 * 8
        tlp2622->tlp_dlen  := m26_dlen     //description length
    endif
    dbcommit()
    dbrunlock()
    return''
//.............................................................................
static function load_format(m26_type)
    local x:=0
    atlp:=array(0,15)
    if o_tlp2622(.t.,.t.)
        if dbseek(m26_type)
            do while !eof() .and. tlp_type = m26_type .and. x < 7
                x := x+1
                aadd(atlp,{'','','','','','','','','','','','','','',''})
                lod_tlp2622(x)
                dbskip()
            enddo
        else
//            if dc_alert("This is a New Type--Add?",{'Yes','No'}) = 1
                for x := 1 to 6
                    dbappend()
                    aadd(atlp,{'','','','','','','','','','','','','','',''})
                    lod_tlp2622(x)
                    tlp2622->tlp_type:=m26_type
                    tlp2622->tlp_line:=ltrim(str(x))
                next
//            endif
        endif
        tlp2622->(dbclosearea())
    endif
return''
//.............................................................................
function lod_tlp2622(x)
    atlp[X,1] := tlp2622->tlp_type
    atlp[X,2] := tlp2622->tlp_line
    atlp[X,3] := tlp2622->tlp_code
    atlp[X,4] := tlp2622->tlp_hor
    atlp[X,5] := tlp2622->tlp_ver
    atlp[X,6] := tlp2622->tlp_rot
    atlp[X,7] := tlp2622->tlp_font
    atlp[X,8] := tlp2622->tlp_hmult
    atlp[X,9] := tlp2622->tlp_vmult
    atlp[X,10] := tlp2622->tlp_image
    atlp[X,11] := tlp2622->tlp_bcode
    atlp[X,12] := tlp2622->tlp_nbw
    atlp[X,13] := tlp2622->tlp_wbw
    atlp[X,14] := tlp2622->tlp_bhght
    atlp[X,15] := tlp2622->tlp_phrc
    if x = 1
//        m26_title  := tlp2622->tlp_title
        m26_pck1   := tlp2622->tlp_pck1
        m26_pck2   := tlp2622->tlp_pck2
        m26_pck3   := tlp2622->tlp_pck3
        m26_pck4   := tlp2622->tlp_pck4
        m26_pck5   := tlp2622->tlp_pck5
        m26_pck6   := tlp2622->tlp_pck6
        m26_fix1   := tlp2622->tlp_fix1
        m26_fix2   := tlp2622->tlp_fix2
        m26_fix3   := tlp2622->tlp_fix3
        m26_fix4   := tlp2622->tlp_fix4
        m26_fix5   := tlp2622->tlp_fix5
        m26_fix6   := tlp2622->tlp_fix6
        m26_fsz1   := tlp2622->tlp_fsz1
        m26_fsz2   := tlp2622->tlp_fsz2
        m26_fsz3   := tlp2622->tlp_fsz3
        m26_fsz4   := tlp2622->tlp_fsz4
        m26_fsz5   := tlp2622->tlp_fsz5
        m26_fsz6   := tlp2622->tlp_fsz6
        m26_p1     := tlp2622->tlp_p1 / 8
        m26_p2     := tlp2622->tlp_p2 / 8
        m26_p3     := tlp2622->tlp_p3 / 8
        m26_w1     := tlp2622->tlp_w1 / 8
        m26_dlen   := tlp2622->tlp_dlen
    endif
    return''
//..................................................................
function bar_range(cVar,br,er)
    local ret_val := .t.
    if val(cVar) >= br .and. val(cVar) <= er
    else
        alertInfo("Range is "+ltrim(str(br))+' to '+ltrim(str(er)))
        ret_val := .f.
    endif
    return ret_val
//..................................................................
function fmt_lines(cVar,aLine,m_view,mdata,y)
    local m_line := "", x:=0
    local mPos := array(6,3)
    local tmp_line := ''
    local mComma1:=mComma2:=mComma3:=0
    local aPick[6]

    for x := 1 to 6 //len(atlp)
        if atlp[x,3] = 'A'
            aLine[x]:=atlp[x,3];
                    +alltrim(atlp[x,4])+',';
                    +alltrim(atlp[x,5])+',';
                    +alltrim(atlp[x,6])+',';
                    +alltrim(atlp[x,7])+',';
                    +alltrim(atlp[x,8])+',';
                    +alltrim(atlp[x,9])+',';
                    +alltrim(atlp[x,10])
        elseif atlp[x,3] = 'B'
            aLine[x]:=atlp[x,3];
                    +alltrim(atlp[x,4])+',';
                    +alltrim(atlp[x,5])+',';
                    +alltrim(atlp[x,6])+',';
                    +alltrim(atlp[x,11])+',';
                    +alltrim(atlp[x,12])+',';
                    +alltrim(atlp[x,13])+',';
                    +alltrim(atlp[x,14])+',';
                    +alltrim(atlp[x,15])
        endif
    next x



    afill(aPick,'')
    aPick[1]:=m26_pck1
    aPick[2]:=m26_pck2
    aPick[3]:=m26_pck3
    aPick[4]:=m26_pck4
    aPick[5]:=m26_pck5
    aPick[6]:=m26_pck6
//get data for the six lines
    for x := 1 to 6
        mPos[x,1]:=0
        mPos[x,2]:=0
        mPos[x,3]:=0
//get the fixed text
        m_line := ''
        tmp_line := ''
        mComma1 := at(',',aPick[x])
        if mComma1 > 0
//two positions
            mPos[x,1] := val(substr(aPick[x],1,mComma1-1))
            tmp_line := substr(aPick[x],mComma1+1)
            mComma2 := at(',',tmp_line)
            if mComma2 > 0
                mPos[x,2]:=val(substr(tmp_line,1,mComma2-1))
                mPos[x,3]:=val(trim(substr(tmp_line,mComma2+1)))
            else
                mPos[x,2]:=val(trim(substr(aPick[x],mComma1+1)))
            endif
        elseif !empty(aPick[x])
//one position
            mPos[x,1] := val(trim(aPick[x]))
//testing alert
//alert('Line '+ltrim(str(x))+' Position '+ltrim(str(mPos[x,1])))
        endif
        for z := 1 to 3
            if mPos[x,z] = 3
                mData[y,mPos[x,z]] := substr(mData[y,mPos[x,z]],1,m26_dlen)
            endif
        next z
        do case
        case mPos[x,3] > 0
            m_line:=trim(mData[y,mPos[x,1]])+' '+;
                trim(mData[y,mPos[x,2]])+' '+;
                trim(mData[y,mPos[x,3]])
        case mPos[x,2] > 0
            m_line:=trim(mData[y,mPos[x,1]])+' '+;
                    trim(mData[y,mPos[x,2]])
        case mPos[x,1] > 0
            m_line:=trim(mData[y,mPos[x,1]])
        otherwise
            m_line :=''
        endcase
        if atlp[x,2] <> '0'
            m_line:=upper(m_line)
        endif
        if m_view = 'Y'
            aLine[x]:=aLine[x]+','+m_line
        else
            aLine[x]:=aLine[x]+',"'+m_line+'"'
        endif
//        msgbox(aline[x])
    next x
return''
//...............................................................
function pick_source(nVar,m_source,msource)
    local getlist := {}
    local title :='Bar Code Printing'
    local ali:={'I','R'}
    local a_li:={'Last In','Total Received'}
    msource[3] := 'I'
    msource[4] := 0
    msource[5] := date()
    do case
    case m_source == 1
        msource[1] := space(16)
        msource[2] := space(16)
        title :='Bar Codes by ID   Label: '+alltrim(m26_title)
        @ 11,  1 dcsay "Starting ID"
        @ 11, 15 dcget msource[1] pict '@!' tabstop;
                 popup{||get_prod2()}
        @ 12,  1 dcsay "Ending ID"
        @ 12, 15 dcget msource[2] pict '@!' tabstop;
                 popup{||get_prod2()}
        @ 13,  1 dcsay "Number to Print"
        @ 13, 15 dcget msource[4] pict '@!' tabstop
        @ 14, 15 dcsay "(0 prints # on hand)" sayfont '8.arial' saycolor 9
    case m_source == 2
        msource[1] := date()
        msource[2] := date()
        title :='Bar Codes by Date Received   Label: '+alltrim(m26_title)
        @ 11, 1 dcsay "Starting Date"
        @ 11, 15 dcget msource[1] tabstop;
                 POPUP {|d|DC_GuiPopDate(d)}
        @ 12, 1 dcsay "Ending Date"
        @ 12, 15 dcget msource[2] tabstop;
                 POPUP {|d|DC_GuiPopDate(d)}
        @ 13, 1 dcsay "What to Print"
        @ 13, 15 dcget msource[3] pict '@!';
                  TABSTOP;
                  GETSIZE 12;
                  GETFONT '8.ARIAL';
                  VALID {|o|ASCAN(aLI,o:GetData()) > 0};
                  COMBO HEIGHT 2.5 DATA a_LI RETURN {|n|aLI[n]}

    case m_source == 3
        msource[1] := space(8)
        msource[2] := space(8)
        title :='Bar Codes by PO   Label: '+alltrim(m26_title)
        @ 11,  1 dcsay "PO Number" saysize 10
        @ 11, 15 dcget msource[1] tabstop;
                 pict '@!'
        @ 12,  1 dcsay "What to Print"
        @ 12, 15 dcget msource[3] pict '@!';
                 TABSTOP;
                 GETSIZE 12;
                 GETFONT '8.ARIAL';
                 VALID {|o|ASCAN(aLI,o:GetData()) > 0};
                 COMBO HEIGHT 2.5 DATA a_LI RETURN {|n|aLI[n]}

        @ 13,  1 dcsay "Date"
        @ 13, 15 dcget msource[5] tabstop;
                 POPUP {|d|DC_GuiPopDate(d)};
                 when {||msource[3] = 'I'}

    case m_source == 4
        msource[1] := Rcvepo->Rcve_1     //prodid
        msource[2] := Rcvepo->Rcve_1     //prodid
        msource[3] := 'R'        //RECEIVE NOW
        msource[4] := Rcvepo->Rcve_2     //number to print
        msource[5] := Rcvepo->Rcve_3     //DATE
/*
        title :='Bar Codes from Receive PO'
        @ 11,  1 dcsay "First ID"
        @ 11, 15 dcget msource[1] pict '@!' tabstop
        @ 12,  1 dcsay "Number to Print"
        @ 12, 15 dcget msource[4] pict '@!' tabstop
        @ 13,  1 dcsay "Date"
        @ 13, 15 dcget msource[5] tabstop
*/
    endcase
    if (m_source=4) .or. EditGui(@GetList,@Process,16,.t.,title)
        do case
        case m_source == 1
            if empty(msource[2]) .and. !empty(msource[1])
                msource[2] := msource[1]
            endif
            if !empty(msource[2])
                if msource[4] == 0
                    msource[3] := 'O'
                else
                    msource[3] := 'N'
                endif
            else
                m_source := 0
            endif
        case m_source == 2
            if !empty(msource[1]) .and. empty(msource[2])
                msource[2] := msource[1]
            endif
            if empty(msource[2]) .or. empty(msource[3])
                m_source := 0
            endif
        case m_source == 3
            if !empty(msource[1])
                msource[2] := msource[1]
            endif
            if empty(msource[2]) .or. empty(msource[3])
                m_source := 0
            endif
        endcase
    else
        m_source := 0
    endif
return .t.
//..............................................................
function get_mdata(mdata,msource,m_source,m_client)
    local mFix := array(6)
    afill(mFix,'')
//m_client =  1 - Gators Monarch 9401 Printer
//            2 - Point of View Monarch 9420/9440 string label printer
//            3 - TLP_2622
    if m_client=3
        if !empty(m26_fix1) .and. m26_fsz1 > 0
            mFix[1]:=substr(m26_fix1,1,m26_fsz1)
        else
            mFix[1]:=(m26_fix1)
        endif
        if !empty(m26_fix2) .and. m26_fsz2 > 0
            mFix[2]:=substr(m26_fix2,1,m26_fsz2)
        else
            mFix[2]:=(m26_fix2)
        endif
        if !empty(m26_fix3) .and. m26_fsz3 > 0
            mFix[3]:=substr(m26_fix3,1,m26_fsz3)
        else
            mFix[3]:=(m26_fix3)
        endif
        if !empty(m26_fix4) .and. m26_fsz4 > 0
            mFix[4]:=substr(m26_fix4,1,m26_fsz4)
        else
            mFix[4]:=(m26_fix4)
        endif
        if !empty(m26_fix5) .and. m26_fsz5 > 0
            mFix[5]:=substr(m26_fix5,1,m26_fsz5)
        else
            mFix[5]:=(m26_fix5)
        endif
        if !empty(m26_fix6) .and. m26_fsz6 > 0
            mFix[6]:=substr(m26_fix6,1,m26_fsz6)
        else
            mFix[6]:=(m26_fix6)
        endif
    endif
    do case
    case m_source == 4    //genx print when receiving
    //this is where the pricing needs to be based on the array
        if o_products(.f.,.t.)
            dbselectarea('Rcvepo')
            do while !Rcvepo->(eof())
//msgbox('Getting Source')
                msource[1] := Rcvepo->Rcve_1     //prodid
                msource[2] := Rcvepo->Rcve_1     //prodid
                msource[3] := 'R'        //RECEIVE NOW
                msource[4] := Rcvepo->Rcve_2     //number to print
                msource[5] := Rcvepo->Rcve_3     //DATE
//msgbox('Got Source')
                if msource[4] > 0
//msgbox('Add to Array')
                    if products->(dbseek(msource[1]))
                        aadd(mData,{trim(products->pupc),;
                            trim(products->prodid),;
                            StrTran(trim(products->pdescrip),'"','\"'),;
                            trim(products->pdept),;
                            trim(products->pclass),;
                            ltrim(str(round(products->plist,2))),;
                            ltrim(str(round(products->prce_a,2))),;
                            ltrim(str(round(products->prce_b,2))),;
                            ltrim(str(round(products->prce_c,2))),;
                            ltrim(str(round(products->prce_d,2))),;
                            ltrim(str(round(products->prce_e,2))),;
                            ltrim(str(products->pounds,5)),;
                            ltrim(str(products->pounces,2)),;
                            trim(products->pyear),;
                            trim(products->pbrand),;
                            trim(products->pmodel),;
                            trim(products->pstyle),;
                            trim(products->pmanufctr),;
                            trim(products->psize),;
                            trim(products->pmake),;
                            trim(products->pcommish),;
                            mfix[1],;
                            mfix[2],;
                            mfix[3],;
                            mfix[4],;
                            mfix[5],;
                            mfix[6],;
                            msource[4],;
                            trim(products->pvndr1),;
                            trim(products->pvndr_id1)})
//msgbox('Added to Array')
                    endif
                endif
                Rcvepo->(dbskip())
            enddo
            products->(dbclosearea())
        endif
    case m_source == 1
//        alert("Getting Manual Labels")
        if o_products(.f.,.t.)
            if dbseek(msource[1])
                do while !eof() .and. products->prodid <= msource[2]
                    if at(products->prtUPCCode,'Y1') = 0
                        dbskip()
                        loop
                    endif
                    if msource[4] > 0 .or. products->pon_hnd > 0
                        if m_client = 1
                            aadd(mData,{products->prodid,;
                                        StrTran(products->pdescrip,'"','\"'),;
                                        round(products->prce_a,2),;
                                        products->pupc,;
                                        products->pupc,;
                                        trim(substr(products->psize,1,3)),;
                                        msource[4]})
                        elseif m_client = 2
                            aadd(mData,{products->pupc,;
                                        StrTran(products->pdescrip,'"','\"'),;
                                        round(products->prce_a,2),;
                                        products->pmodel,;
                                        products->pmake,;
                                        trim(products->psize),;
                                        msource[4]})
                        elseif m_client = 3
                            aadd(mData,{trim(products->pupc),;
                                trim(products->prodid),;
                                trim(StrTran(products->pdescrip,'"','\"')),;
                                trim(products->pdept),;
                                trim(products->pclass),;
                                ltrim(str(round(products->plist,2))),;
                                ltrim(str(round(products->prce_a,2))),;
                                ltrim(str(round(products->prce_b,2))),;
                                ltrim(str(round(products->prce_c,2))),;
                                ltrim(str(round(products->prce_d,2))),;
                                ltrim(str(round(products->prce_e,2))),;
                                ltrim(str(products->pounds,5)),;
                                ltrim(str(products->pounces,2)),;
                                trim(products->pyear),;
                                trim(products->pbrand),;
                                trim(products->pmodel),;
                                trim(products->pstyle),;
                                trim(products->pmanufctr),;
                                trim(products->psize),;
                                trim(products->pmake),;
                                trim(products->pcommish),;
                                mfix[1],;
                                mfix[2],;
                                mfix[3],;
                                mfix[4],;
                                mfix[5],;
                                mfix[6],;
                                0,;
                                trim(products->pvndr1),;
                                trim(products->pvndr_id1)})
                        endif
                        mNum := len(mData)
                        if msource[4] == 0
                            if m_client < 3
                                mData[mNum][7] := products->pon_hnd
                            else
                                mData[mNum][28] := products->pon_hnd
                            endif
                        else
                            mData[mNum][28] := msource[4]
                        endif
                        if mData[mNum][28] = 0
                            alertInfo(products->prodid+' 0 QTY TO PRINT')
                        endif
                    endif
                    dbskip()
                enddo
            else
                alertInfo(msource[1]+' Not Found')
            endif
            products->(dbclosearea())
        endif
    case m_source == 2
//        alert("Getting PO Labels for Date Range")
        if o_products(.f.,.t.)
            if o_purords(.f.,.t.)
                dbsetorder(2)
                set softseek on
                dbseek(dtos(msource[1]))
                if eof()
                    alertInfo(dtos(msource[1])+' Date Not Found')
                endif
                do while !eof()
                    if purords->o_lst_in >= msource[1];
                        .and. purords->o_lst_in <= msource[2]
                        if msource[3] == 'I' .and. int(purords->o_qlst_in) = 0
                            dbskip()
                            loop
                        elseif msource[3] == 'R'.and. int(purords->o_cmn_in) = 0
                            dbskip()
                            loop
                        endif
                        if substr(purords->o_prodid,1,7) = 'SHIP-PO'
                            dbskip()
                            loop
                        endif
                        if products->(dbseek(purords->o_prodid));
                            .and. at(products->prtUPCCode,'Y1') > 0
                            if m_client < 3
                                aadd(mData,{purords->o_prodid,;
                                        "",;
                                        0,;
                                        "",;
                                        "",;
                                        "",;
                                        0})
                            else
                                aadd(mData,{trim(products->pupc),;
                                        trim(products->prodid),;
                                        trim(StrTran(products->pdescrip,'"','\"')),;
                                        trim(products->pdept),;
                                        trim(products->pclass),;
                                        ltrim(str(round(products->plist,2))),;
                                        ltrim(str(round(products->prce_a,2))),;
                                        ltrim(str(round(products->prce_b,2))),;
                                        ltrim(str(round(products->prce_c,2))),;
                                        ltrim(str(round(products->prce_d,2))),;
                                        ltrim(str(round(products->prce_e,2))),;
                                        ltrim(str(products->pounds,5)),;
                                        ltrim(str(products->pounces,2)),;
                                        trim(products->pyear),;
                                        trim(products->pbrand),;
                                        trim(products->pmodel),;
                                        trim(products->pstyle),;
                                        trim(products->pmanufctr),;
                                        trim(products->psize),;
                                        trim(products->pmake),;
                                        trim(products->pcommish),;
                                        mfix[1],;
                                        mfix[2],;
                                        mfix[3],;
                                        mfix[4],;
                                        mfix[5],;
                                        mfix[6],;
                                        0,;
                                        trim(products->pvndr1),;
                                        trim(products->pvndr_id1)})
                            endif
                            mNum := len(mData)
                            if m_client = 1
                                mData[mNum][2] := StrTran(products->pdescrip,'"','\"')
                                mData[mNum][3] := round(products->prce_a,2)
                                mData[mNum][4] := products->pupc
                                mData[mNum][5] := products->pupc
                                mData[mNum][6] := trim(products->psize)//+' '+trim(products->pstyle)
                                if products->prtUPCCode=='1'
                                    mData[mNum][7] := 1
                                elseif msource[3] == 'I'
                                    mData[mNum][7] := int(purords->o_qlst_in * products->pmaster)
                                elseif msource[3] == 'R'
                                    mData[mNum][7] := int(purords->o_cmn_in * products->pmaster)
                                endif
                            elseif m_client = 2
                                mData[mNum][1] := products->pupc
                                mData[mNum][2] := StrTran(products->pdescrip,'"','\"')
                                mData[mNum][3] := round(products->prce_a,2)
                                mData[mNum][4] := products->pmodel
                                mData[mNum][5] := products->pmake
                                mData[mNum][6] := trim(products->psize)
                                if products->prtUPCCode=='1'
                                    mData[mNum][7] := 1
                                elseif msource[3] == 'I'
                                    mData[mNum][7] := int(purords->o_qlst_in * products->pmaster)
                                elseif msource[3] == 'R'
                                    mData[mNum][7] := int(purords->o_cmn_in * products->pmaster)
                                endif
                            elseif m_client = 3
                                if products->prtUPCCode=='1'
                                    mData[mNum][28] := 1
                                elseif msource[3] == 'I'
                                    mData[mNum][28] := int(purords->o_qlst_in * products->pmaster)
                                elseif msource[3] == 'R'
                                    mData[mNum][28] := int(purords->o_cmn_in * products->pmaster)
                                endif
                            endif
                        endif
                    endif
                    dbskip()
                enddo
                purords->(dbclosearea())
            endif
            products->(dbclosearea())
        endif
    case m_source == 3
//        alert("Getting Single PO Labels for "+msource[1]+' '+msource[2])//
        if o_products(.f.,.t.)
            if o_purords(.f.,.t.)
                dbsetorder(3)
                dbseek(msource[1])
                if eof()
                    alertInfo(msource[1]+' Not Found')
                endif
                do while !eof() .and. purords->o_po_num <= msource[2]
                    if msource[3] = 'I' .and. purords->o_lst_in <> msource[5]
                        dbskip()
                        loop
                    endif
                    if msource[3] == 'I' .and. int(purords->o_qlst_in) = 0
                        dbskip()
                        loop
                    endif
                    if msource[3] == 'R'.and. int(purords->o_cmn_in) = 0
                        dbskip()
                        loop
                    endif
                    if substr(purords->o_prodid,1,7) = 'SHIP-PO'
                        dbskip()
                        loop
                    endif
                    if products->(dbseek(purords->o_prodid));
                        .and. at(products->prtUPCCode,'Y1') > 0
                        if m_client < 3
                            aadd(mData,{purords->o_prodid,;
                                "",;
                                0,;
                                "",;
                                "",;
                                "",;
                                0})
                        else
                                aadd(mData,{trim(products->pupc),;
                                        trim(products->prodid),;
                                        trim(StrTran(products->pdescrip,'"','\"')),;
                                        trim(products->pdept),;
                                        trim(products->pclass),;
                                        ltrim(str(round(products->plist,2))),;
                                        ltrim(str(round(products->prce_a,2))),;
                                        ltrim(str(round(products->prce_b,2))),;
                                        ltrim(str(round(products->prce_c,2))),;
                                        ltrim(str(round(products->prce_d,2))),;
                                        ltrim(str(round(products->prce_e,2))),;
                                        ltrim(str(products->pounds,5)),;
                                        ltrim(str(products->pounces,2)),;
                                        trim(products->pyear),;
                                        trim(products->pbrand),;
                                        trim(products->pmodel),;
                                        trim(products->pstyle),;
                                        trim(products->pmanufctr),;
                                        trim(products->psize),;
                                        trim(products->pmake),;
                                        trim(products->pcommish),;
                                        mfix[1],;
                                        mfix[2],;
                                        mfix[3],;
                                        mfix[4],;
                                        mfix[5],;
                                        mfix[6],;
                                        0,;
                                        trim(products->pvndr1),;
                                        trim(products->pvndr_id1)})
                        endif
                        mNum := len(mData)
                        if m_client = 1
                            mData[mNum][2] := StrTran(products->pdescrip,'"','\"')
                            mData[mNum][3] := round(products->prce_a,2)
                            mData[mNum][4] := products->pupc
                            mData[mNum][5] := products->pupc
                            mData[mNum][6] := trim(products->psize)//+' '+trim(products->pstyle)
                            if products->prtUPCCode=='1'
                                mData[mNum][7] := 1
                            elseif msource[3] == 'I'
                                mData[mNum][7] := int(purords->o_qlst_in * products->pmaster)
                            elseif msource[3] == 'R'
                                mData[mNum][7] := int(purords->o_cmn_in * products->pmaster)
                            endif
                        elseif m_client = 2
                            mData[mNum][1] := products->pupc
                            mData[mNum][2] := StrTran(products->pdescrip,'"','\"')
                            mData[mNum][3] := round(products->prce_a,2)
                            mData[mNum][4] := products->pmodel
                            mData[mNum][5] := products->pmake
                            mData[mNum][6] := trim(products->psize)
                            if products->prtUPCCode=='1'
                                mData[mNum][7] := 1
                            elseif msource[3] == 'I'
                                mData[mNum][7] := int(purords->o_qlst_in * products->pmaster)
                            elseif msource[3] == 'R'
                                mData[mNum][7] := int(purords->o_cmn_in * products->pmaster)
                            endif
                        elseif m_client = 3
                            if products->prtUPCCode=='1'
                                mData[mNum][28] := 1
                            elseif msource[3] == 'I'
                                mData[mNum][28] := int(purords->o_qlst_in * products->pmaster)
                            elseif msource[3] == 'R'
                                mData[mNum][28] := int(purords->o_cmn_in * products->pmaster)
                            endif
                        endif
//                    else
//                        alertInfo(purords->o_prodid+" Not Found")
//this comes up when print upc is set to N ... very annoying
                    endif
                    dbskip()
                enddo
                purords->(dbclosearea())
            endif
            products->(dbclosearea())
        endif
    endcase
return mdata
/*
    local cType:=0, rCnt:=0, scr
    private lupy:=.f.
//    set key K_SH_F10 to Add_Definition
    do while .t.
        tlplbl->(dbgotop())
        rCnt:=RecCount()
        @ 3,25 clear to (6+rCnt+1),75
        scr:=SaveScreen(3, 25, (6+rCnt+1),75)
        @ 3, 25 to 6+rCnt+1,75 double
        @ 4, 26 say padc('Select Label to Use',48)
        @ 6+rCnt, 30 say '[SH-F10] to Add New Definition'
        @ 5, 26 to 5,74 double
        @ 5, 76 say ''
        while .not. eof()
            @ row()+1, 30 prompt tlp_Type + ' '+tlp_title
            dbskip()
        end
        menu to cType
        if lupy
            lupy:=.f.
            loop
        endif
        if lastkey()=K_ESC
            cType:=0
            exit
        else
            tlplbl->(dbseek(ltrim(str(cType))))
            m26_title:=tlplbl->tlp_title
            m26_DELAY:=tlplbl->tlp_delay
            m26_port:=tlplbl->tlp_port
            exit
        endif
    enddo
    RestScreen(3, 25, (6+rCnt+1),75,scr)
    set key K_SH_F10  to COPYRIGHT   // Version Release Date Serial Analysis
    return ltrim(str(cType))
*/

**************[ Barcode Type Selection ]*************************
function bcode_sel(m_sel)
    local getlist:={}
    local m_type:=m_sel


    @ 1, 5 DCRADIO m_type PROMPT 'UCC/EAN 128' VALUE '0'
    @ 2, 5 DCRADIO m_type PROMPT 'Code 128 A,B,C' VALUE '1'
    @ 3, 5 DCRADIO m_type PROMPT 'Interleaved 2 of 5' VALUE '2'
    @ 4, 5 DCRADIO m_type PROMPT 'Code 39 std or ext' VALUE '3'
    @ 5, 5 DCRADIO m_type PROMPT 'Code 93' VALUE '9'
    @ 6, 5 DCRADIO m_type PROMPT 'Codabar' VALUE 'K'
    @ 7, 5 DCRADIO m_type PROMPT 'Discrete 2 of 5' VALUE 'U'

    AddEditButtons(@GetList,@Process,13,.t.)
    DCGETOPTIONS NORESIZE NOMAXBUTTON  sayfont '10.arial'

    DCREAD GUI MODAL FIT;
    CLEAREVENTS;
    OPTIONS GetOptions;
        TITLE "Barcode Selection"

ret_val:=m_type

return ret_val


**************[ Font Selection ]*************************
function font_sel(m_sel1)
    local getlist:={}
    local m_font1:=m_sel1

    @ 1, 5 DCRADIO m_font1 PROMPT '20.3 cpi,  6 point' VALUE '1'
    @ 2, 5 DCRADIO m_font1 PROMPT '16.9 cpi,  7 point' VALUE '2'
    @ 3, 5 DCRADIO m_font1 PROMPT '14.5 cpi, 10 point' VALUE '3'
    @ 4, 5 DCRADIO m_font1 PROMPT '12.7 cpi, 12 point' VALUE '4'
    @ 5, 5 DCRADIO m_font1 PROMPT '5.6 cpi, 24 point' VALUE '5'


    AddEditButtons(@GetList,@Process,13,.t.)
    DCGETOPTIONS NORESIZE NOMAXBUTTON  sayfont '10.arial'

    DCREAD GUI MODAL FIT;
    CLEAREVENTS;
    OPTIONS GetOptions;
        TITLE "Font Selection"

ret_val:=m_font1

return ret_val
//..............................................................
static function get_prod2()
    local ret_val:=''
    if o_products(.f.,.t.)
        if DNBROWSER('P','','',0)
                ret_val = products->prodid
        endif
    endif
    products->(dbclosearea())
    return ret_val
//..............................................................
//................................
FUNCTION GETWPRINT()
local oPrinter, aPrintList
local ret_val:=" "

   oPrinter             := XbpPrinter():new()
   aPrinterList         := oPrinter:list()

   IF aPrinterList == NIL
      MsgBox( "Error - There are no printers installed!", "Error" )
   else
//   ret_val:= apicker(aPrinterList,{"Select"},{35},"Printers")
ret_val:=aPrinterList
   ENDIF

return ret_val